﻿------------------------------------------------------------------------------------------
--Bar Creation----------------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")

--local width, height = 300, 24
local RAID_CLASS_COLORS = RAID_CLASS_COLORS
local GetSpellInfo = GetSpellInfo
local UnitClass = UnitClass
local IsAddOnLoaded = IsAddOnLoaded

function SN:CreateBar(group, cooldown, duration, caster, guid, spell, width, height, fontSize, font, texture)

	--Make our lives easier with some variables
	local class, classFileName, classID = UnitClass(caster)
	
	local bar = T:NewBar(nil, width, height, texture)
	--Start the CD Timer
	if (IsAddOnLoaded("ElvUI")) then
		SN:SNCreateBG(bar, "StatusBar")
	else
		bar:SetAlpha(1)
		bar:SetBackdrop({
			bgFile = M.media.blankTex, 
			edgeFile = M.media.blankTex, 
			tile = false, tileSize = 0, edgeSize = 2, 
			insets = { left = -2, right = 2, top = 2, bottom = -2 }
		})
		bar:SetBackdropColor(0, 0, 0, 0)
		bar:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	end
	
	--Grab the player's class color and the icon of the spell
	local colortmp = RAID_CLASS_COLORS[classFileName]
	local color = { colortmp.r, colortmp.g, colortmp.b }
	local _, _, icon = GetSpellInfo(cooldown)
	
	bar:SetIcon(icon)
	bar:SetColor(color)
	bar:SetDuration(duration)
	bar:SetDurationFont(font, fontSize)
	bar:SetLabelFont(font, fontSize)
	
	--Setup the data keys that the bar will hold
	bar:SetData("SN:arg1", group)
	bar:SetData("SN:arg2", cooldown)
	bar:SetData("SN:arg3", guid)
	bar:SetData("SN:arg4", caster)
	bar:SetData("SN:arg5", spell)
	bar:SetData("SN:arg6", classID)
	bar:SetData("SN:arg7", duration)
	bar.TimeSinceLastUpdate = 0
	
	--Make sure only the CD monitor gets the caster and spell names
	if group == F.debuffs then
		bar:SetLabel(spell)
	elseif group == F.cooldowns then
		bar:SetLabel(caster.."       "..spell)
	elseif group == F.cc then
		bar:SetLabel(spell.. "   "..UnitName(SN:GUIDToUnitID(guid)))
	end
	--bar:RegisterCallback("FancyBar_BarStop", BarCleanup)
	group:Add(bar)
	bar:Start()
end

function SN:EditBars(group)
	local frame

	if group == "cc" then
		frame = F.cc
	elseif group == "cooldown" then
		frame = F.cooldowns
	else
		frame = F.debuffs
	end
	SN:Debug(group)
	SN:Debug(SN.data.profile.frames[group])
	frame:SetPoint(unpack(SN.data.profile.frames[group]))
	frame:SetStartPoint(SN.data.profile[group].grow)
	frame:SetWidth(SN.data.profile[group].width)

	if frame.bars ~= nil then
		for i in pairs(frame.bars) do
			i:SetHeight(SN.data.profile[group].height)
			i:SetLabelFont(LSM:Fetch("font", SN.data.profile[group].font), SN.data.profile[group].fontsize)
			i:SetDurationFont(LSM:Fetch("font", SN.data.profile[group].font), SN.data.profile[group].fontsize)
			i:SetTexture(LSM:Fetch("statusbar", SN.data.profile[group].texture))
		end
	end
	if SN.data.profile[group].iconmode then
		frame:SetIconMode(32 * SN.data.profile[group].iconscale, "BOTTOM", 0, 0)
		frame:SetSpacing(SN.data.profile[group].fontsize / 2, SN.data.profile[group].fontsize + 3)
	else
		frame:SetIconMode(false)
		frame:SetSpacing(0, 3)
	end
end